--Sonic Boom (ROM hack) moveset made in Lua by Pixel-Voxel
--I feel as though there's a lot of redundancy in this code to fix. Enjoy.

addHook("ThinkFrame",function()
	for player in players.iterate
		--Making sure the ability variables exist (to ensure it won't break for skin switchers).
		if player.kicked == nil
			player.kicked = 0
		end

		if player.downwarddivin == nil
			player.downwarddivin = 0
		end

		if player.downwarddelay == nil
			player.downwarddelay = 0
		end

		if player.diagonaldashin == nil
			player.diagonaldashin = 0
		end

		if player.peelout == nil
			player.peelout = 0
		end

		if player.peeling == nil
			player.peeling = 0
		end

		if player.abilityused == nil
			player.abilityused = 0
		end

		--Making sure you're actually playing the game.
		if player.mo == nil
			continue
		end

		--Sonic only from here on out.
		if player.mo.skin ~= "sonic"
			continue
		end

		player.charability = CA_DOUBLEJUMP

		--Flying Kick
		if not (player.cmd.buttons & BT_CUSTOM1)
			player.onetapready = true
			player.onetapping = false
		elseif player.onetapready
			player.onetapping = true
			player.onetapready = false
		else
			player.onetapping = false
		end

		if player.onetapping
		and not player.abilityused
		and (player.health >= 6)
		and (player.mo.health >= 6)
		and not (player.pflags & (PF_ROPEHANG|PF_CARRIED|PF_ITEMHANG|PF_MACESPIN|PF_TIMEOVER|PF_STASIS|PF_TAGGED))
		and not P_IsObjectOnGround(player.mo)
		and not (player.mo.tracer and player.mo.tracer.type == MT_TUBEWAYPOINT)
		and not player.exiting
			A_Thrust(player.mo,45,1)
			S_StartSound(player.mo,sfx_zoom,player)
			player.mo.state = S_PLAY_PAIN
			player.pflags = $1|PF_JUMPED
			player.pflags = $1|PF_SPINNING
			player.pflags = $1|PF_THOKKED
			player.kicked = 1
			player.abilityused = 1
			player.health = $1 - 5
			player.mo.health = $1 - 5
		end

		if player.kicked
			player.mo.state = S_PLAY_PAIN

			if P_IsObjectOnGround(player.mo)
				player.mo.state = S_PLAY_RUN1
				player.kicked = 0
			end

			if player.health == 0
			and player.mo.health == 0
				player.mo.state = S_PLAY_DIE
				player.kicked = 0
			end
		end

		--WALK TO WIN
		if not (player.peelout)
			if P_IsObjectOnGround(player.mo)
			and (player.cmd.buttons & BT_CUSTOM1)
			and not (player.mo.tracer and player.mo.tracer.type == MT_TUBEWAYPOINT)
			and not player.exiting
				player.normalspeed = 16*FRACUNIT
			else
				player.normalspeed = 36*FRACUNIT
			end
		end

		--Diagonal Dash
		if not (player.cmd.buttons & BT_CUSTOM2)
			player.twotapready = true
			player.twotapping = false
		elseif player.twotapready
			player.twotapping = true
			player.twotapready = false
		else
			player.twotapping = false
		end

		if player.twotapping
		and not player.abilityused
		and (player.health >= 3)
		and (player.mo.health >= 3)
		and not (player.pflags & (PF_ROPEHANG|PF_CARRIED|PF_ITEMHANG|PF_MACESPIN|PF_TIMEOVER|PF_STASIS|PF_TAGGED))
		and not P_IsObjectOnGround(player.mo)
		and not (player.mo.tracer and player.mo.tracer.type == MT_TUBEWAYPOINT)
		and not player.exiting
			A_Thrust(player.mo,30,1)
			P_SetObjectMomZ(player.mo,-25*FRACUNIT)
			S_StartSound(player.mo,sfx_zoom,player)
			player.diagonaldashin = 1
			player.pflags = $1|PF_JUMPED
			player.pflags = $1|PF_SPINNING
			player.pflags = $1|PF_THOKKED
			player.abilityused = 1
			player.mo.state = S_PLAY_FALL1
			player.health = $1 - 2
			player.mo.health = $1 - 2
		end

		--Downward Dive behavior (Essentially making it the Stomp. Eh.)
		if player.downwarddivin
			A_Thrust(player.mo,0,1)
		end

		if player.downwarddelay > 0
			player.downwarddelay = $1 - 1
		end

		--Super Peelout
		if (player.cmd.buttons & BT_CUSTOM3)
		and P_IsObjectOnGround(player.mo)
		and player.speed == 0
		and player.peelout < 20
		and not (player.pflags & (PF_ROPEHANG|PF_CARRIED|PF_ITEMHANG|PF_MACESPIN|PF_TIMEOVER|PF_STASIS|PF_TAGGED|PF_SPINNING))
		and not (player.mo.tracer and player.mo.tracer.type == MT_TUBEWAYPOINT)
		and not player.exiting
			if player.peelout < 1
				S_StartSound(player.mo,sfx_spin,player)
			end

			player.peelout = $1 + 1
			player.normalspeed = 0
		end

		if player.peelout
			if player.powers[pw_super] == 0
				player.mo.state = S_PLAY_RUN1
			else
				player.mo.state = S_PLAY_SPD1
			end

			player.normalspeed = 0
		end

		if not (player.cmd.buttons & BT_CUSTOM3)
		and P_IsObjectOnGround(player.mo)
			if player.peelout < 20
				player.peelout = 0
			else
				player.peelout = 0
				player.peeling = 35
				S_StartSound(player.mo,sfx_zoom,player)
			end

			if not (player.cmd.buttons & BT_CUSTOM1)
				player.normalspeed =  36*FRACUNIT
			end
		end

		if player.peeling
			if player.powers[pw_super] == 0
				A_Thrust(player.mo,50,1)
			else
				A_Thrust(player.mo,70,1)
			end

			player.peeling = $1 - 1
			player.charflags = $1|SF_NOSKID

			if not (player.mo.state >= S_PLAY_SPD1
			and player.mo.state <= S_PLAY_SPD4)
			and P_IsObjectOnGround(player.mo)
			and not (player.pflags & PF_SPINNING)
				player.mo.state = S_PLAY_SPD1
				player.panim = PA_RUN
			end
		end

		--Cancelling things.
		if (P_IsObjectOnGround(player.mo) or P_IsObjectInGoop(player.mo))
			player.downwarddivin = 0
			player.diagonaldashin = 0
		end

		if (player.downwarddivin or player.diagonaldashin)
		and P_MobjFlip(player.mo)*player.mo.momz > 0
			if (player.downwarddivin)
				player.downwarddelay = 35
			end

			player.downwarddivin = 0
			player.diagonaldashin = 0
			player.abilityused = 0
			P_SetObjectMomZ(player.mo,5*FRACUNIT)
		end

		if P_IsObjectOnGround(player.mo)
		and player.abilityused
			player.abilityused = 0
		end

		if not P_IsObjectOnGround(player.mo)
		or (player.pflags & (PF_ROPEHANG|PF_CARRIED|PF_ITEMHANG|PF_MACESPIN|PF_TIMEOVER|PF_STASIS|PF_TAGGED|PF_SPINNING))
		or (player.mo.tracer and player.mo.tracer.type == MT_TUBEWAYPOINT)
		or player.exiting
		or (player.mo.state == S_PLAY_PAIN)
		or (player.mo.state == S_PLAY_DIE)
		or (player.mo.state == S_PLAY_GASP)
			player.peelout = 0
			player.peeling = 0
			player.normalspeed = 36*FRACUNIT
		end

		if not player.peeling
			player.charflags = $1 & ~(SF_NOSKID)
		end
	end
end)

addHook("SpinSpecial",function(player)
	if not P_IsObjectOnGround(player.mo)
	and player.mo.skin == "sonic"
	and not player.abilityused
	and not player.downwarddelay
	and (player.health >= 2)
	and (player.mo.health >= 2)
	and (player.pflags & PF_JUMPED)
	and not (player.pflags & (PF_ROPEHANG|PF_CARRIED|PF_ITEMHANG|PF_MACESPIN|PF_TIMEOVER|PF_STASIS|PF_TAGGED))
	and not (player.mo.tracer and player.mo.tracer.type == MT_TUBEWAYPOINT)
	and not player.exiting
		A_Thrust(player.mo,0,1)
		P_SetObjectMomZ(player.mo,-25*FRACUNIT)
		player.downwarddivin = 1
		player.pflags = $1|PF_JUMPED
		player.pflags = $1|PF_THOKKED
		player.abilityused = 1
		player.health = $1 - 1
		player.mo.health = $1 - 1
		return true
	end

	if not P_IsObjectOnGround(player.mo)
	and player.mo.skin == "sonic"
	and not (player.pflags & (PF_ROPEHANG|PF_CARRIED|PF_ITEMHANG|PF_MACESPIN|PF_TIMEOVER|PF_STASIS|PF_TAGGED|PF_JUMPED))
	and not (player.mo.tracer and player.mo.tracer.type == MT_TUBEWAYPOINT)
		player.pflags = $1|PF_JUMPED
		player.pflags = $1|PF_SPINNING
		player.abilityused = 1
		return true
	end
end)